/* Algoritmul. lui Dijkstra
    Complexitate: O(n * n)
*/
#include <fstream>
using namespace std;

ifstream fin("graf.in");
ofstream fout("graf.out");

const int MaxN = 100, Inf = 0x3f3f3f3f;
int c[MaxN][MaxN];   // matrice aponderilor
bool v[MaxN];
int d[MaxN];         // d[x] = distanta minima de la nodul sursa la nodul x
int S;               // nodul sursa
int n;

void ReadGraph();
void Dijkstra();

int main()
{
    ReadGraph();
    S = 1;
    Dijkstra();

    for (int x = 1; x <= n; ++x)
        fout << d[x] << ' ';

    fin.close();
    fout.close();
}


void Dijkstra()
{
    for (int x = 1; x <= n; ++x)
        d[x] = c[S][x];

    v[S] = true;
    for (int pas = 1; pas < n; ++pas)
    {
        int k, dmin = Inf;
        for (int x = 1; x <= n; ++x)
            if (d[x] < dmin && !v[x])
            {
               dmin = d[x];
               k = x;
            }

        v[k] = true;

        for (int x = 1; x <= n; ++x)
            if ( d[x] > d[k] + c[k][x])
                d[x] = d[k] + c[k][x];
    }
}

void ReadGraph()
{
    fin >> n;
    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= n; ++j)
            if (i != j)
                c[i][j] = Inf;
    int x, y, w;

    while (fin >> x >> y >> w)
        c[x][y] = c[y][x] = w;

}
