/* Algoritmul. lui Dijkstra
    Complexitate: O(n * log m)
*/
#include <fstream>
#include <vector>
#include <algorithm>
#include <queue>
using namespace std;

using VI = vector<int>;
using PII = pair<int, int>;

ifstream fin("graf.in");
ofstream fout("graf.out");

struct Pair {
    int dist, node;
    bool operator < (const Pair& p) const
    {
        return dist > p.dist;
    }
};

const int Inf = 0x3f3f3f3f;
vector<vector<PII>> G;   // graful
int n;
VI d;       // d[x] = distanta minima d ela nodul sursa la nodul x

void ReadGraph();
void Dijkstra(int x, VI& d);

int main()
{
    ReadGraph();
    Dijkstra(1, d);

    for (int x = 2; x <= n; ++x)
        if (d[x] == Inf)
            fout << "0 ";
        else
            fout << d[x] << ' ';

    fin.close();
    fout.close();
}

void Dijkstra(int x, VI& d)   // x = nodul sursa
{
    // greater pentru a obtin un Min-Heap
    priority_queue<Pair> Q;
    d = VI(n + 1, Inf);
    d[x] = 0;     // distanta sursa-sursa
    Q.push({0, x});

    int y, dx, w;

    while (!Q.empty())
    {
        x = Q.top().node; // aflam nodul din varful cozii
        dx = Q.top().dist;
        Q.pop();         // sterg elementul din varul cozii
        if (dx > d[x])
            continue;

        for (auto& p : G[x])
        {
            y = p.first;
            w = p.second;

            if (d[y] > d[x] + w)
            {
                d[y] = d[x] + w;
                Q.push({d[y], y});
            }
        }
    }
}

void ReadGraph()
{
    int m;
    fin >> n >> m;
    G = vector<vector<PII>>(n + 1);

    int x, y, w;

    while (m--)
    {
        fin >> x >> y >> w;
        G[x].push_back({y, w});
   //     G[y].push_back({x, w});
    }
}
